<?php
/*
	*********************************************************************
	* Copyright by Andre Lorbach | 2006!								*
	* -> www.ultrastats.org <-											*
	*																	*
	* Use this script at your own risk!									*
	* -----------------------------------------------------------------	*
	* Parser Medal functions											*
	*																	*
	* -> 		*
	*																	*
	* All directives are explained within this file						*
	*********************************************************************
*/

function CreateAllMedals( $serverid )
{
	global $myserver, $content;

	// Now we create overall Medals!
	if ( $serverid != -1 ) 
		PrintHTMLDebugInfo( DEBUG_INFO, "Medal", "Starting Medal Calculation for Server " . $serverid . " ...");
	else
		PrintHTMLDebugInfo( DEBUG_INFO, "Medal", "Starting Total Medal Calculation ...");


	if ( $serverid != -1 )
	{
		$wheresinglesql = " WHERE SERVERID = " . $serverid;
		$whereaddsql = " AND SERVERID = " . $serverid;
	}
	else
	{
		$wheresinglesql = " WHERE 1 = 1 ";	// needed as we scan for banned players also | Dummy 1=1 for AND queries
		$whereaddsql = "";
	}

	// Clean up Medals
	ProcessDeleteStatement("DELETE FROM " . STATS_CONSOLIDATED . " WHERE NAME LIKE 'medal_%' AND SERVERID = " . $serverid);

	// ========================== PRO MEDALS =================================
	// --- Calc: medal_pro_killer
	$sqlquery =	"SELECT " .
				STATS_PLAYER_KILLS . ".PLAYERID, " .
				" sum(" . STATS_PLAYER_KILLS . ".Kills) as AllKills" . 
				" FROM " . STATS_PLAYER_KILLS . 
				$wheresinglesql .
				GetBannedPlayerWhereQuery(STATS_PLAYER_KILLS, "PLAYERID", false) . 
				" GROUP BY " . STATS_PLAYER_KILLS . ".PLAYERID " . 
				" ORDER BY AllKills DESC LIMIT 1";
	PrintHTMLDebugInfo( DEBUG_ULTRADEBUG, "Medal", "medal_pro_killer: " . $sqlquery );

	$topplayer = ReturnMedalValue($sqlquery);
	if ( isset($topplayer['PLAYERID']) )
		InsertOrUpdateMedalValue(	"medal_pro_killer", 
									"Killer", 
									$serverid, 
									"medal_pro_killer", 
									$topplayer['AllKills'], 
									"Kills", 
									$topplayer['PLAYERID'],
									0 );
	else
		PrintHTMLDebugInfo( DEBUG_INFO, "Medal", "medal_pro_killer is empty!" );
	// --- 

	// --- Calc: medal_pro_headshot
	$sqlquery =	"SELECT " .
				STATS_PLAYER_KILLS . ".PLAYERID, " .
				" sum(" . STATS_PLAYER_KILLS . ".Kills) as AllKills" . 
				" FROM " . STATS_PLAYER_KILLS . 
				" INNER JOIN (" . STATS_HITLOCATIONS . 
				") ON (" . 
				STATS_HITLOCATIONS . ".ID=" . STATS_PLAYER_KILLS . ".HITLOCATIONID) " . 
				" WHERE " . STATS_HITLOCATIONS . ".BODYPART = '" . "head" . "'" . 
				$whereaddsql . 
				GetBannedPlayerWhereQuery(STATS_PLAYER_KILLS, "PLAYERID", false) . 
				" GROUP BY " . STATS_PLAYER_KILLS . ".PLAYERID " . 
				" ORDER BY AllKills DESC LIMIT 1";
	PrintHTMLDebugInfo( DEBUG_ULTRADEBUG, "Medal", "medal_pro_headshot: " . $sqlquery );

	$topplayer = ReturnMedalValue($sqlquery);
	if ( isset($topplayer['PLAYERID']) )
		InsertOrUpdateMedalValue(	"medal_pro_headshot", 
									"Headshot", 
									$serverid, 
									"medal_pro_headshot", 
									$topplayer['AllKills'], 
									"Kills", 
									$topplayer['PLAYERID'],
									1 );
	else
		PrintHTMLDebugInfo( DEBUG_INFO, "Medal", "medal_pro_headshot is empty!" );
	// --- 
	
	// --- Calc: medal_pro_explosivekiller
	$sqlquery =	"SELECT " .
				STATS_PLAYER_KILLS . ".PLAYERID, " .
				" sum(" . STATS_PLAYER_KILLS . ".Kills) as AllKills" . 
				" FROM " . STATS_PLAYER_KILLS . 
				" INNER JOIN (" . STATS_DAMAGETYPES . 
				") ON (" . 
				STATS_DAMAGETYPES . ".ID=" . STATS_PLAYER_KILLS . ".DAMAGETYPEID) " . 
				" WHERE " . STATS_DAMAGETYPES . ".DAMAGETYPE IN ('MOD_GRENADE_SPLASH' )" . 
				$whereaddsql . 
				GetBannedPlayerWhereQuery(STATS_PLAYER_KILLS, "PLAYERID", false) . 
				" GROUP BY " . STATS_PLAYER_KILLS . ".PLAYERID " . 
				" ORDER BY AllKills DESC LIMIT 1";
	PrintHTMLDebugInfo( DEBUG_ULTRADEBUG, "Medal", "medal_pro_explosivekiller: " . $sqlquery );

	$topplayer = ReturnMedalValue($sqlquery);
	if ( isset($topplayer['PLAYERID']) )
		InsertOrUpdateMedalValue(	"medal_pro_explosivekiller", 
									"Explosive Killer", 
									$serverid, 
									"medal_pro_explosivekiller", 
									$topplayer['AllKills'], 
									"Kills", 
									$topplayer['PLAYERID'],
									2 );
	else
		PrintHTMLDebugInfo( DEBUG_INFO, "Medal", "medal_pro_explosivekiller is empty!" );
	// --- 

	// --- Calc: medal_pro_slappyhappy
	$sqlquery =	"SELECT " .
				STATS_PLAYER_KILLS . ".PLAYERID, " .
				" sum(" . STATS_PLAYER_KILLS . ".Kills) as AllKills" . 
				" FROM " . STATS_PLAYER_KILLS . 
				" INNER JOIN (" . STATS_DAMAGETYPES . 
				") ON (" . 
				STATS_DAMAGETYPES . ".ID=" . STATS_PLAYER_KILLS . ".DAMAGETYPEID) " . 
				" WHERE " . STATS_DAMAGETYPES . ".DAMAGETYPE IN ('MOD_MELEE')" . 
				$whereaddsql . 
				GetBannedPlayerWhereQuery(STATS_PLAYER_KILLS, "PLAYERID", false) . 
				" GROUP BY " . STATS_PLAYER_KILLS . ".PLAYERID " . 
				" ORDER BY AllKills DESC LIMIT 1";
	PrintHTMLDebugInfo( DEBUG_ULTRADEBUG, "Medal", "medal_pro_slappyhappy: " . $sqlquery );

	$topplayer = ReturnMedalValue($sqlquery);
	if ( isset($topplayer['PLAYERID']) )
		InsertOrUpdateMedalValue(	"medal_pro_slappyhappy", 
									"Slappy Happy", 
									$serverid, 
									"medal_pro_slappyhappy", 
									$topplayer['AllKills'], 
									"Kills", 
									$topplayer['PLAYERID'],
									3 );
	else
		PrintHTMLDebugInfo( DEBUG_INFO, "Medal", "medal_pro_slappyhappy is empty!" );
	// --- 

	// --- Calc: medal_pro_sniper
	$sqlquery =	"SELECT " .
				STATS_PLAYER_KILLS . ".PLAYERID, " .
				" sum(" . STATS_PLAYER_KILLS . ".Kills) as AllKills" . 
				" FROM " . STATS_PLAYER_KILLS . 
				" INNER JOIN (" . STATS_WEAPONS . 
				") ON (" . 
				STATS_WEAPONS . ".ID=" . STATS_PLAYER_KILLS . ".WEAPONID) " . 
				" WHERE " . STATS_WEAPONS . ".INGAMENAME IN ('springfield_mp', 'enfield_scope_mp', 'kar98k_sniper_mp', 'mosin_nagant_sniper_mp')" . 
				$whereaddsql . 
				GetBannedPlayerWhereQuery(STATS_PLAYER_KILLS, "PLAYERID", false) . 
				" GROUP BY " . STATS_PLAYER_KILLS . ".PLAYERID " . 
				" ORDER BY AllKills DESC LIMIT 1";
	PrintHTMLDebugInfo( DEBUG_ULTRADEBUG, "Medal", "medal_pro_sniper: " . $sqlquery );

	$topplayer = ReturnMedalValue($sqlquery);
	if ( isset($topplayer['PLAYERID']) )
		InsertOrUpdateMedalValue(	"medal_pro_sniper", 
									"Sniper", 
									$serverid, 
									"medal_pro_sniper", 
									$topplayer['AllKills'], 
									"Kills", 
									$topplayer['PLAYERID'],
									4 );
	else
		PrintHTMLDebugInfo( DEBUG_INFO, "Medal", "medal_pro_sniper is empty!" );
	// --- 

	// --- Calc: medal_pro_pistol
	$sqlquery =   "SELECT " . 
				STATS_PLAYER_KILLS . ".PLAYERID, " . 
				" sum(" . STATS_PLAYER_KILLS . ".Kills) as AllKills" . 
				" FROM " . STATS_PLAYER_KILLS . 
				" INNER JOIN (" . STATS_WEAPONS . 
				") ON (" . 
				STATS_WEAPONS . ".ID=" . STATS_PLAYER_KILLS . ".WEAPONID) " . 
				" WHERE " . STATS_WEAPONS . ".WeaponType IN ('" . WEAPONTYPE_PISTOL . "')" . 
				$whereaddsql . 
				GetBannedPlayerWhereQuery(STATS_PLAYER_KILLS, "PLAYERID", false) . 
				" GROUP BY " . STATS_PLAYER_KILLS . ".PLAYERID " . 
				" ORDER BY AllKills DESC LIMIT 1";
   // Credits to "SaCkS" ;), I just added the static defs into functions_constats.php

	PrintHTMLDebugInfo( DEBUG_ULTRADEBUG, "Medal", "medal_pro_pistol: " . $sqlquery );

	$topplayer = ReturnMedalValue($sqlquery);
	if ( isset($topplayer['PLAYERID']) )
		InsertOrUpdateMedalValue(	"medal_pro_pistol", 
									"Pistol", 
									$serverid, 
									"medal_pro_pistol", 
									$topplayer['AllKills'], 
									"Kills", 
									$topplayer['PLAYERID'],
									5 );
	else
		PrintHTMLDebugInfo( DEBUG_INFO, "Medal", "medal_pro_pistol is empty!" );
	// --- 
	// ==========================            =================================


	// ========================== ANTI MEDALS =================================
	// --- Calc: medal_anti_no1target
	$sqlquery =	"SELECT " .
				STATS_PLAYER_KILLS . ".ENEMYID, " .
				" sum(" . STATS_PLAYER_KILLS . ".Kills) as AllKills" . 
				" FROM " . STATS_PLAYER_KILLS . 
				$wheresinglesql .
				GetBannedPlayerWhereQuery(STATS_PLAYER_KILLS, "ENEMYID", false) . 
				" GROUP BY " . STATS_PLAYER_KILLS . ".ENEMYID " . 
				" ORDER BY AllKills DESC LIMIT 1";
	PrintHTMLDebugInfo( DEBUG_ULTRADEBUG, "Medal", "medal_anti_no1target: " . $sqlquery );

	$topplayer = ReturnMedalValue($sqlquery);
	if ( isset($topplayer['ENEMYID']) )
		InsertOrUpdateMedalValue(	"medal_anti_no1target", 
									"No 1 Target", 
									$serverid, 
									"medal_anti_no1target", 
									$topplayer['AllKills'], 
									"Deaths", 
									$topplayer['ENEMYID'],
									0 );
	else
		PrintHTMLDebugInfo( DEBUG_INFO, "Medal", "medal_anti_no1target is empty!" );
	// --- 

	// --- Calc: medal_anti_teamkiller
	$sqlquery =	"SELECT " .
				STATS_PLAYERS . ".GUID, " .
				" sum(" . STATS_PLAYERS . ".Teamkills) as AllKills" . 
				" FROM " . STATS_PLAYERS . 
				$wheresinglesql .
				GetBannedPlayerWhereQuery(STATS_PLAYERS, "GUID", false) . 
				" GROUP BY " . STATS_PLAYERS . ".GUID " . 
				" ORDER BY AllKills DESC LIMIT 1";
	PrintHTMLDebugInfo( DEBUG_ULTRADEBUG, "Medal", "medal_anti_teamkiller: " . $sqlquery );

	$topplayer = ReturnMedalValue($sqlquery);
	if ( isset($topplayer['GUID']) )
		InsertOrUpdateMedalValue(	"medal_anti_teamkiller", 
									"Teamkiller", 
									$serverid, 
									"medal_anti_teamkiller", 
									$topplayer['AllKills'], 
									"Kills", 
									$topplayer['GUID'],
									1 );
	else
		PrintHTMLDebugInfo( DEBUG_INFO, "Medal", "medal_anti_teamkiller is empty!" );
	// --- 

	// --- Calc: medal_anti_suicide
	$sqlquery =	"SELECT " .
				STATS_PLAYERS . ".GUID, " .
				" sum(" . STATS_PLAYERS . ".Suicides) as AllKills" . 
				" FROM " . STATS_PLAYERS . 
				$wheresinglesql .
				GetBannedPlayerWhereQuery(STATS_PLAYERS, "GUID", false) . 
				" GROUP BY " . STATS_PLAYERS . ".GUID " . 
				" ORDER BY AllKills DESC LIMIT 1";
	PrintHTMLDebugInfo( DEBUG_ULTRADEBUG, "Medal", "medal_anti_suicide: " . $sqlquery );

	$topplayer = ReturnMedalValue($sqlquery);
	if ( isset($topplayer['GUID']) )
		InsertOrUpdateMedalValue(	"medal_anti_suicide", 
									"Suicide", 
									$serverid, 
									"medal_anti_suicide", 
									$topplayer['AllKills'], 
									"Deaths", 
									$topplayer['GUID'],
									2 );
	else
		PrintHTMLDebugInfo( DEBUG_INFO, "Medal", "medal_anti_suicide is empty!" );
	// --- 

	// --- Calc: medal_anti_nademagnet
	$sqlquery =	"SELECT " .
				STATS_PLAYER_KILLS . ".ENEMYID, " .
				" sum(" . STATS_PLAYER_KILLS . ".Kills) as AllKills" . 
				" FROM " . STATS_PLAYER_KILLS . 
				" INNER JOIN (" . STATS_DAMAGETYPES . 
				") ON (" . 
				STATS_DAMAGETYPES . ".ID=" . STATS_PLAYER_KILLS . ".DAMAGETYPEID) " . 
				" WHERE " . STATS_DAMAGETYPES . ".DAMAGETYPE IN ('MOD_GRENADE_SPLASH' )" . 
				$whereaddsql . 
				GetBannedPlayerWhereQuery(STATS_PLAYER_KILLS, "ENEMYID", false) . 
				" GROUP BY " . STATS_PLAYER_KILLS . ".ENEMYID " . 
				" ORDER BY AllKills DESC LIMIT 1";
	PrintHTMLDebugInfo( DEBUG_ULTRADEBUG, "Medal", "medal_anti_nademagnet: " . $sqlquery );

	$topplayer = ReturnMedalValue($sqlquery);
	if ( isset($topplayer['ENEMYID']) )
		InsertOrUpdateMedalValue(	"medal_anti_nademagnet", 
									"Nade Magnet", 
									$serverid, 
									"medal_anti_nademagnet", 
									$topplayer['AllKills'], 
									"Deaths", 
									$topplayer['ENEMYID'],
									3 );
	else
		PrintHTMLDebugInfo( DEBUG_INFO, "Medal", "medal_anti_nademagnet is empty!" );
	// --- 

	// --- Calc: medal_anti_whiner
	$sqlquery =	"SELECT " .
				STATS_CHAT . ".PLAYERID, " .
				" count(" . STATS_CHAT . ".ID) as Count" . 
				" FROM " . STATS_CHAT . 
				" WHERE (" . ReturnWhinerQuery() . ") " . 
				$whereaddsql . 
				GetBannedPlayerWhereQuery(STATS_CHAT, "PLAYERID", false) . 
				" GROUP BY " . STATS_CHAT . ".PLAYERID " . 
				" ORDER BY Count DESC LIMIT 1";
	PrintHTMLDebugInfo( DEBUG_ULTRADEBUG, "Medal", "medal_anti_whiner: " . $sqlquery );

	$topplayer = ReturnMedalValue($sqlquery);
	if ( isset($topplayer['PLAYERID']) )
		InsertOrUpdateMedalValue(	"medal_anti_whiner", 
									"Whiner", 
									$serverid, 
									"medal_anti_whiner", 
									$topplayer['Count'], 
									"Whining chats", 
									$topplayer['PLAYERID'],
									4 );
	else
		PrintHTMLDebugInfo( DEBUG_INFO, "Medal", "medal_anti_whiner is empty!" );
	// --- 

	// ==========================            =================================

	// Finished
	PrintHTMLDebugInfo( DEBUG_INFO, "Medal", "Finished Medal Calculation...");
}

function ReturnMedalValue( $mySqlCommand )
{
	$result = DB_Query($mySqlCommand);
	$tmpvar = DB_GetSingleRow($result, true);
	if ( isset($tmpvar) )
		return $tmpvar;
	else
		return;
}

function InsertOrUpdateMedalValue( $myname, $mydisplayname, $myserverid, $DescriptionStringID, $valueInt, $valueStr, $PlayerID, $SortID )
{
	PrintHTMLDebugInfo( DEBUG_DEBUG, "InsertOrUpdateMedalValue", "Adding/Updating New Medal '" . $myname . "', PlayerID '" . $PlayerID . "'");
	$wherequery =	"WHERE SERVERID = " . $myserverid . " AND 
					NAME = '" . $myname . "'"; 

	$result = DB_Query("SELECT ID FROM " . STATS_CONSOLIDATED . " " . $wherequery );
	$rows = DB_GetAllRows($result, true);
	if ( isset($rows) )
	{
		// Update Calc
		ProcessUpdateStatement("UPDATE " . STATS_CONSOLIDATED . " SET 
									PLAYER_ID = " . $PlayerID . ", 
									VALUE_INT = " . $valueInt . ", 
									VALUE_TXT = '" . $valueStr . "' " . $wherequery, true );
	}
	else
	{
		// Insert New
		ProcessInsertStatement("INSERT INTO " . STATS_CONSOLIDATED . " (NAME, SERVERID, DisplayName, DescriptionID, VALUE_INT, VALUE_TXT, PLAYER_ID, SortID) 
		VALUES (
			 '" . $myname . "', 
			 " . $myserverid . ", 
			 '" . $mydisplayname . "', 
			 '" . $DescriptionStringID . "', 
			 " . $valueInt . ", 
			 '" . $valueStr . "', 
			 " . $PlayerID . ", 
			 " . $SortID . ")");
	}
}


function ReturnWhinerQuery()
{
	// Helper function which returns whiner words as a list for a query! 
	$whining = Array(
						'noob', 'cheat', 'camper', 'hurensohn', 'fucking', 'wallhacker', 'deine mudda', 
						'nap', 'nerd', 'gay', 'hure', 'bastard', 'spasst', 'fick', 'sucker', 'arsch', 'pisser',
						'luckor', 'sau', 'wixer', 'bettnsser', 'n00b', 'hoden', 'pissnelke', 'huras', 'deine mutter',
						'mowl', 'bitch', 'slut', 'motherfuck', 'assi', 'drecks', 'nigg', 'fresse', 'spack', 
						'shout up', 'stfu', 'hax0r', 'n00b', 'hate', 'sheiss', 'Affe', 'negg', 'lutscher',
						'idiot', 'hdf' //, '', 'n00b', 'hate', 'sheiss', 'Affe', 'negg', 'lutscher',
					);
	foreach ($whining as $myword )
	{
		if ( !isset($whiningstr) )
			$whiningstr = "TextSaid LIKE '%" . $myword . "%' ";
		else
			$whiningstr .= " OR TextSaid LIKE '%" . $myword . "%' ";
	}

	// return string
	return $whiningstr;
}
?>